#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_SeniorDrawCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_SeniorDrawCFG> Fish_SeniorDrawCFG::msSingleton(nullptr);

int Fish_SeniorDrawCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_SeniorDrawCFGData* Fish_SeniorDrawCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_SeniorDrawCFGData>& Fish_SeniorDrawCFG::GetMapData()
{
	return mMapData;
}

void Fish_SeniorDrawCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_SeniorDrawCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_SeniorDrawCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mFishId = element->IntAttribute("FishId");
		{
			const char* GraphicalId = element->Attribute("GraphicalId");
			std::vector<std::string> vecGraphicalId;
			boost::split(vecGraphicalId, GraphicalId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecGraphicalId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecGraphicalId[i].c_str(), &temp))
				{
					data.mGraphicalId.push_back(temp);
				}
			}
		}
		data.mmult = element->IntAttribute("mult");
		data.mLotteryProbability = element->IntAttribute("LotteryProbability");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_SeniorDrawCFG::Load()
{
	Load("../Config/Fish_SeniorDrawCFG.xml");
}

Fish_SeniorDrawCFG* Fish_SeniorDrawCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_SeniorDrawCFG());
	}
	return msSingleton.get();
}
